unit HiAdapterInfo;  {  AdapterInfo (     ) ver 1.00 }

interface

uses Windows,KOL,KOLComObj,ActiveX,Share,Debug;

const STGM_default =STGM_READWRITE + STGM_SHARE_EXCLUSIVE;
      STGM_BASE    =STGM_READ + STGM_SHARE_EXCLUSIVE;

const
  MAX_ADAPTER_NAME_LENGTH = 256;
  MAX_ADAPTER_DESCRIPTION_LENGTH = 128;
  MAX_ADAPTER_ADDRESS_LENGTH = 8;

type
//------IP address structures---------------------------------------------------
  PIP_ADDRESS_STRING = ^IP_ADDRESS_STRING;
  IP_ADDRESS_STRING = array[0..15] of char; // IP as string

  PIP_ADDR_STRING = ^IP_ADDR_STRING;
  IP_ADDR_STRING = record
    Next: PIP_ADDR_STRING;
    IpAddress: IP_ADDRESS_STRING;
    IpMask: IP_ADDRESS_STRING;
    Context: DWORD;
  end;
//------ADAPTER INFO STRUCTURES-------------------------------------------------
  PIP_ADAPTER_INFO = ^IP_ADAPTER_INFO;
  IP_ADAPTER_INFO = record
    Next: PIP_ADAPTER_INFO;
    ComboIndex: DWORD;
    AdapterName: array[1..MAX_ADAPTER_NAME_LENGTH + 4] of char;
    Description: array[1..MAX_ADAPTER_DESCRIPTION_LENGTH + 4] of char;
    AddressLength: UINT;
    Address: array[1..MAX_ADAPTER_ADDRESS_LENGTH] of byte;
    Index: DWORD;
    aType: UINT;
    DHCPEnabled: UINT;
    CurrentIPAddress: PIP_ADDR_STRING;
    IPAddressList: IP_ADDR_STRING;
    GatewayList: IP_ADDR_STRING;
    DHCPServer: IP_ADDR_STRING;
    HaveWINS: BOOL;
    PrimaryWINSServer: IP_ADDR_STRING;
    SecondaryWINSServer: IP_ADDR_STRING;
    LeaseObtained: LongInt;
    LeaseExpires: LongInt;
    SpareStuff: array [1..200] of char;
  end;
  
type
  TScriptLanguage = (slVBScript, slJScript);
  
type
  THiAdapterInfo = class(TDebug)
   private
      FMAC: string;
      FIP: string;
      FMask: string;
      FGateway: string;
      SystemName   : string;
      Name         : string;
      ServiceName  : string;
      Description  : string;
      Manufacturer : string;
      AdapterType  : string;
      DeviceID     : string;
      PNPDeviceID  : string;
      MACAddress   : string;
      IP           : string;
      Mask         : string;
      Gateway      : string;
      procedure ScanIP(MAC: string);      
   public
      _event_onInfo: THI_Event;
      _event_onEndEnum: THI_Event;
      constructor Create;
      destructor Destroy; override;      
      procedure _work_doInfo(var _Data:TData; Index:word);
      procedure _var_SystemName(var _Data:TData; Index:word);
      procedure _var_Name(var _Data:TData; Index:word);
      procedure _var_ServiceName(var _Data:TData; Index:word);
      procedure _var_Description(var _Data:TData; Index:word);
      procedure _var_Manufacturer(var _Data:TData; Index:word);
      procedure _var_AdapterType(var _Data:TData; Index:word);
      procedure _var_DeviceID(var _Data:TData; Index:word);
      procedure _var_PNPDeviceID(var _Data:TData; Index:word);
      procedure _var_MACAddress(var _Data:TData; Index:word);
      procedure _var_IP(var _Data:TData; Index:word);
      procedure _var_Mask(var _Data:TData; Index:word);
      procedure _var_Gateway(var _Data:TData; Index:word);
 end;

implementation

function  GetAdaptersInfo(pAdapterInfo: PIP_ADAPTER_INFO; pOutBufLen: PULONG): DWORD; stdcall;
          external 'Iphlpapi.dll' name 'GetAdaptersInfo';

const
  NULL_GUID: TGUID = '{00000000-0000-0000-0000-000000000000}';

var
  ScriptCLSIDs: array[TScriptLanguage] of TGUID;

const
  ScriptProgIDs: array[TScriptLanguage] of PWideChar = (
    'VBScript',
    'JScript'
  );

procedure InitCLSIDs;
var
  L: TScriptLanguage;
begin
  for L := Low(TScriptLanguage) to High(TScriptLanguage) do
    if CLSIDFromProgID(ScriptProgIDs[L], ScriptCLSIDs[L]) <> S_OK
      then ScriptCLSIDs[L] := NULL_GUID;
end;

constructor THiAdapterInfo.Create;
begin
  inherited;
  OleInit;
  InitCLSIDs;
end;

destructor THiAdapterInfo.Destroy;
begin
   OleUnInit;
   inherited;
end;

function GetObject(const name:string; accs:dword=STGM_default): Variant;
var   err:HResult;
      bo:tBINDOPTS;
      res:IDispatch;
      nm:widestring;
begin
   nm := name;
   fillchar(bo,sizeof(bo),0);
   with bo do begin cbStruct := sizeof(bo);
      grfFlags := BIND_MAYBOTHERUSER;
      grfMode := accs;
   end;
   err := CoGetObject(  @nm[1] , @bo , IDispatch , @res );
   OleCheck(err);
   Result := res;
end;

procedure THiAdapterInfo.ScanIP;
var
   L: DWORD;
   Size: DWORD;
   i: DWORD;
   Next: PIP_ADAPTER_INFO;
begin
   Size := Sizeof( IP_ADAPTER_INFO );
   Next := AllocMem( Size );
   L:= GetAdaptersInfo(Next, @Size);
   if L = ERROR_BUFFER_OVERFLOW then
   begin
      FreeMem( Next );
      Next := AllocMem( Size );
      L:= GetAdaptersInfo(Next, @Size);
   end;
   if L = NO_ERROR then begin
      repeat
         FMAC:= '';
         for i := 1 to Next^.AddressLength do begin
            FMAC:= FMAC + Int2Hex(Next^.Address[i], 2);
            if i <> Next^.AddressLength then FMAC:= FMAC + ':';
         end;
         FIP := Next^.IPAddressList.IpAddress;
         FMask := Next^.IPAddressList.IpMask;
         FGateway := Next^.GatewayList.IpAddress;
         if FMAC = MAC then begin
            IP := FIP;
            Mask := FMask;
            Gateway := FGateway;
            Exit;
         end; 
         Next:= Next^.Next; //    
      until Next = nil;
   end;
end;

procedure THiAdapterInfo._work_doInfo;
var   objService: Variant;
      objNetAdapter: Variant;
      colNetAdapters: Variant;
      oEnum : IEnumvariant;
      iValue : PLongint;
begin
   objService := GetObject('winmgmts:{impersonationLevel=impersonate}!\\.\root\CIMV2');
   colNetAdapters := objService.ExecQuery('SELECT * FROM Win32_NetworkAdapter');
   oEnum := IUnknown(colNetAdapters._NewEnum) as IEnumVariant;
   iValue := nil;
   while oEnum.Next(1,objNetAdapter,iValue) = 0 do begin
      SystemName := VarToStr(objNetAdapter.SystemName);
      Name := VarToStr(objNetAdapter.Name);
      ServiceName := VarToStr(objNetAdapter.ServiceName);
      Description := VarToStr(objNetAdapter.Description);
      Manufacturer := VarToStr(objNetAdapter.Manufacturer);
      AdapterType := VarToStr(objNetAdapter.AdapterType);
      DeviceID := VarToStr(objNetAdapter.DeviceID);
      PNPDeviceID := VarToStr(objNetAdapter.PNPDeviceID);
      MACAddress := VarToStr(objNetAdapter.MACAddress);
      IP := '';
      Mask := '';
      Gateway := '';
      if MACAddress <> '' then ScanIP(MACAddress);
      _hi_onEvent(_event_onInfo);
      objNetAdapter := Unassigned;
   end;
   _hi_CreateEvent(_Data, @_event_onEndEnum, colNetAdapters.Count); 
end;

procedure THiAdapterInfo._var_SystemName;begin dtString(_Data,SystemName);end;
procedure THiAdapterInfo._var_Name;begin dtString(_Data,Name);end;
procedure THiAdapterInfo._var_ServiceName;begin dtString(_Data,ServiceName);end;
procedure THiAdapterInfo._var_Description;begin dtString(_Data,Description);end;
procedure THiAdapterInfo._var_Manufacturer;begin dtString(_Data,Manufacturer);end;
procedure THiAdapterInfo._var_AdapterType;begin dtString(_Data,AdapterType);end;
procedure THiAdapterInfo._var_DeviceID;begin dtString(_Data,DeviceID);end;
procedure THiAdapterInfo._var_PNPDeviceID;begin dtString(_Data,PNPDeviceID);end;
procedure THiAdapterInfo._var_MACAddress;begin dtString(_Data,MACAddress);end;
procedure THiAdapterInfo._var_IP;begin dtString(_Data,IP);end;
procedure THiAdapterInfo._var_Mask;begin dtString(_Data,Mask);end;
procedure THiAdapterInfo._var_Gateway;begin dtString(_Data,Gateway);end;

end.


